#pragma once

#include <iostream>
#include <vector>

struct Node {
	size_t ID_node;
	std::vector<double> coord;
	bool flag;

	Node(size_t p_ID_node, std::vector<double> p_coord, bool p_flag) :
		ID_node(p_ID_node),
		coord(std::move(p_coord)),
		flag(p_flag) {};
	friend std::ostream& operator << (std::ostream& out, const Node& elem);
		
};

struct FiniteElement {
	size_t ID, ID_material;
	std::vector<size_t> material;
	
	FiniteElement(size_t p_ID, size_t p_ID_material, std::vector<size_t> p_materual) :
		ID(p_ID),
		ID_material(p_ID),
		material(std::move(p_materual)) {};

	friend std::ostream& operator << (std::ostream& out, const FiniteElement& elem);
};

struct BoundaryFiniteElement {
	size_t ID_boundary, ID_surface;
	std::vector<size_t> node_boundary;

	BoundaryFiniteElement(size_t p_ID_boundary, size_t p_ID_surface, std::vector<size_t>p_node_boundary) :
		ID_boundary(p_ID_boundary),
		ID_surface(p_ID_surface),
		node_boundary(std::move(p_node_boundary)) {};

	friend std::ostream& operator << (std::ostream& out, const BoundaryFiniteElement& elem);
};

struct Edge {
	size_t head_id;
	size_t tail_id;
	size_t self_id;
	Edge() = default;
	Edge(size_t p_head_id, size_t p_tail_id) :
		head_id(p_head_id),
		tail_id(p_tail_id) {};

	bool operator == (const Edge& p) const;
};

struct HashEdge {
	void hash_combine(size_t& seed, const size_t& val) const;
	std::size_t operator() (const Edge& p) const;

};
